;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         A.N.Other <myemail@nowhere.com>
;
; Script Function:
;	Template script (you can customize this template by editing "ShellNew\Template.ahk" in your Windows folder)
;

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
CoordMode Mouse, Screen
CoordMode Pixel, Screen
SetBatchLines , -1
SetTitleMatchMode, 1
#MaxHotkeysPerInterval 200

Version = v1.14

#Persistent
#SingleInstance force
#include chooseColor.ahk
#include Lib\Gdip.ahk
#include Lib\AHKHID.ahk

OnExit, AppQuit

IniRead, mDisabled, crosshair.ini, Startup, Cross_Disabled, 0
IniRead, mCentered, crosshair.ini, Startup, Cross_Centered, 0

IniRead, xDisabled, crosshair.ini, Startup, xCross_Disabled, 1
IniRead, xCross_Size, crosshair.ini, Startup, xCross_Size, 128

IniRead, rDisabled, crosshair.ini, Startup, rCross_Disabled, 1
IniRead, rCross_Size, crosshair.ini, Startup, rCross_Size, 128

IniRead, mThickness, crosshair.ini, Startup, Thickness, 1
IniRead, mInvert, crosshair.ini, Startup, Invert, 0
IniRead, mRGBColor, crosshair.ini, Startup, RGBColor, 0x000000
IniRead, mAlpha, crosshair.ini, Startup, Opacity, 255
IniRead, mExcludeMode, crosshair.ini, Startup, ExcludeMode, 0
IniRead, mCursorTrail, crosshair.ini, Startup, CursorTrail, 0

IniRead, cross_Offset_X, crosshair.ini, Startup, cross_Offset_X, 0
IniRead, cross_Offset_Y, crosshair.ini, Startup, cross_Offset_Y, 0
IniRead, cross_rOffset_Y, crosshair.ini, Startup, cross_rOffset_Y, 0

IniRead, ToggleMouseButton, crosshair.ini, Startup, ToggleMouseButton, Hotkey
IniRead, toggleHotkey, crosshair.ini, Startup, Toggle_Hotkey, ^!x

if (ToggleMouseButton != "" && ToggleMouseButton != "Hotkey")
{
	keyTmp := "~" . ToggleMouseButton
	Hotkey, %keyTmp%, ToggleCrosshair, On
	Hotkey, %keyTmp% Up, ToggleCrosshair, On
	
	keyTmp := "~*" . ToggleMouseButton
	Hotkey, %keyTmp%, ToggleCrosshair, On
	Hotkey, %keyTmp% Up, ToggleCrosshair, On
}
else if (toggleHotkey != "")
	Hotkey, %toggleHotkey%, ToggleCrosshair, On
	

IniRead, ToggleHotkeyX, crosshair.ini, Startup, Toggle_HotkeyX

; released under Terms of EUPL 1.0
; (w) by derRaphael Dec 01, 2008

g_isDirty := True
mActive := True

gosub CheckMon

GNum := 0

hFormat= ""
hFamily= ""
hFont= ""

GDIBegin()


; ================================================================
; Crosshair
; ================================================================

CreateGDI("hCross", mWidth, mThickness)
CreateGDI("vCross", mThickness, mHeight)

; ================================================================
; X Crosshair
; ================================================================
CreateGDI("xCross", xCross_Size, xCross_Size)

; ================================================================
; Angular Crosshair
; ================================================================
CreateGDI("rCross", rCross_Size, rCross_Size)
CreateGDI("wCross", xCross_Size, xCross_Size)
rOffset := 0
rZero := 0

; ================================================================
; paper trail
; ================================================================

GNum++
Gui, %GNum%: -Resize -Caption +E0x80000 +E0x20 +LastFound +AlwaysOnTop +ToolWindow +OwnDialogs
Gui, %GNum%: Show, NA
ptrail_hWnd := WinExist()

ptrail_width := 500
ptrail_height := 400
ptrail_hbm := CreateDIBSection(ptrail_width, ptrail_height), ptrail_hdc := CreateCompatibleDC()
ptrail_obm := SelectObject(ptrail_hdc, ptrail_hbm), ptrail_G := Gdip_GraphicsFromHDC(ptrail_hdc)

Gdip_SetSmoothingMode(ptrail_G, 3)
Gdip_SetCompositingMode(ptrail_G, 1)              ; set overdraw
Gdip_SetInterpolationMode(ptrail_G, 1)	 ; lo quality

ptrail_ofsX := 0
ptrail_ofsY := 0

UpdateLayeredWindow(ptrail_hWnd, ptrail_hdc, ptrail_ofsX, ptrail_ofsY, ptrail_width, ptrail_height)



; ================================================================

IniRead, NumApps, crosshair.ini, Startup, Num_Apps, 0
Loop, %NumApps%
{
	IniRead, AppName, crosshair.ini, Apps, %A_Index%
	GroupAdd, CrossWinGroup, ahk_class %AppName%
}

Menu, tray, Icon, crosshair.ico

Menu, tray, NoStandard
Menu, tray, Add, Show Crosshair, Menu_ToggleCrosshair
Menu, tray, Default, Show Crosshair

Menu, tray, Add, Centered Crosshair, Menu_ToggleCenteredCrosshair

Menu, tray, Add, Show X-Crosshair, Menu_ToggleXCrosshair
Menu, tray, Add, Set X-Crosshair Size, Menu_SetXCrossSize

Menu, tray, Add, Show R-Crosshair, Menu_ToggleRCrosshair
Menu, tray, Add, Set R-Crosshair Size, Menu_SetRCrossSize

Menu, tray, Add
Menu, tray, Add, Set Toggle Hotkey, Menu_SetToggleHotkeyWindow

Menu, tray, Add, Show Cursor Trail, Menu_SetCursorTrail
Menu, tray, Add, Exclude Mode, Menu_ToggleExcludeMode

Menu, tray, Add
Menu, tray, Add, Hook/Unhook a program, Menu_ToggleProgram

Menu, tray, Add
Menu, tray, Add, Set Crosshair Thickness, Menu_SetThickness
Menu, tray, Add, Set Crosshair Opacity, Menu_SetOpacity
Menu, tray, Add, Set Crosshair Horizontal Offset, Menu_SetHorizontalOffset
Menu, tray, Add, Set Crosshair Vertical Offset, Menu_SetVerticalOffset
Menu, tray, Add, Set R Crosshair Vertical Offset, Menu_SetRVerticalOffset
Menu, tray, Add, Set Crosshair Colour, Menu_SetColour
Menu, tray, Add, Use Invert Colour, Menu_SetInvert

Menu, tray, Add
Menu, tray, Add, Help
Menu, tray, Add, About Crosshair %Version%, About

Menu, tray, Add
Menu, tray, Add, Quit

Menu, tray, Click, 1

Gosub UpdateMenu

if (m_ExcludeMode == false)
{
	if (NumApps == 0)
		TrayTip, Crosshair %Version%, Crosshair has not been enabled with any programs!`nRight-click me to add more!
	else if (NumApps == 1)
		TrayTip, Crosshair %Version%, Crosshair has only been enabled for %AppName%!`nRight-click me to add more!
	else
		TrayTip, Crosshair %Version%, Crosshair has been enabled for %NumApps% programs!`nClick me to enable/disable them.
}

hGui := WinExist()

;Intercept WM_INPUT
OnMessage(0x00FF, "InputMsg")

captureMouse := false
q := AHKHID_Register(1, 2, hGui, RIDEV_INPUTSINK) ; mouse


gosub RunLoop

return

; ===============================================================================
; Running loop
; ===============================================================================

RunLoop:

if (mExcludeMode)
	WinWaitNotActive ahk_group CrossWinGroup
else
	WinWaitActive ahk_group CrossWinGroup
	
Gosub CheckMon
SetTimer, crosshair, 1
if (mCursorTrail)
	gosub PTrail_Enable

mActive := True

if (mExcludeMode)
	WinWaitActive ahk_group CrossWinGroup
else
	WinWaitNotActive ahk_group CrossWinGroup

mActive := False
gosub crosshairDestroy
gosub PTrail_Disable

Goto RunLoop

return

; ===============================================================================
; Menu Functions
; ===============================================================================

Menu_ToggleCrosshair:
	TrayTip, Crosshair, Crosshair has been toggled.
	mDisabled := mDisabled ? False : True
	IniWrite, %mDisabled%, crosshair.ini, Startup, Cross_Disabled
	Gosub UpdateMenu
	
	if (mDisabled)
		gosub crosshairDestroy
		
	if (mActive)
		SetTimer, crosshair, 1
return

Menu_ToggleCenteredCrosshair:
	TrayTip, Crosshair, Centered Crosshair has been toggled.
	mCentered := mCentered ? False : True
	IniWrite, %mCentered%, crosshair.ini, Startup, Cross_Centered
	Gosub UpdateMenu
return

Menu_ToggleXCrosshair:
	TrayTip, Crosshair, X-Crosshair has been toggled.
	xDisabled := xDisabled ? False : True
	IniWrite, %xDisabled%, crosshair.ini, Startup, xCross_Disabled
	Gosub UpdateMenu
	
	if (xDisabled)
		gosub crosshairDestroy
		
return

Menu_SetXCrossSize:
	InputBox, newSize, Set X-Crosshair Size, Enter an integer between 16-2048,,,,,,,,%xCross_Size%
	if (ErrorLevel == 0)
		if newSize is integer
			xCross_Size := newSize < 16 ? 16
					: newSize > 2048 ? 2048
					: newSize
	IniWrite, %xCross_Size%, crosshair.ini, Startup, xCross_Size
	xCross.Width := xCross_Size
	xCross.Height := xCross_Size
	HideGDI("xCross")
	Reload
return

Menu_ToggleRCrosshair:
	TrayTip, Crosshair, R-Crosshair has been toggled.
	rDisabled := rDisabled ? False : True
	IniWrite, %rDisabled%, crosshair.ini, Startup, rCross_Disabled
	Gosub UpdateMenu
	
	if (rDisabled)
		gosub crosshairDestroy
		
return

Menu_SetRCrossSize:
	InputBox, newSize, Set R-Crosshair Size, Enter an integer between 16-2048,,,,,,,,%rCross_Size%
	if (ErrorLevel == 0)
		if newSize is integer
			rCross_Size := newSize < 16 ? 16
					: newSize > 2048 ? 2048
					: newSize
	IniWrite, %rCross_Size%, crosshair.ini, Startup, rCross_Size
	rCross.Width := rCross_Size
	rCross.Height := rCross_Size
	HideGDI("rCross")
	Reload
return



Menu_SetHorizontalOffset:
	InputBox, newOfs, Set Horizontal Offset, Enter an integer between -9999-9999,,,,,,,,%cross_Offset_X%
	if (ErrorLevel == 0)
		if newOfs is integer
			cross_Offset_X := newOfs < -9999 ? -9999
					: newOfs > 9999 ? 9999
					: newOfs
	IniWrite, %cross_Offset_X%, crosshair.ini, Startup, Cross_Offset_X
return

Menu_SetVerticalOffset:
	InputBox, newOfs, Set Vertical Offset, Enter an integer between -9999-9999,,,,,,,,%cross_Offset_Y%
	if (ErrorLevel == 0)
		if newOfs is integer
			cross_Offset_Y := newOfs < -9999 ? -9999
					: newOfs > 9999 ? 9999
					: newOfs
	IniWrite, %cross_Offset_Y%, crosshair.ini, Startup, cross_Offset_Y
return

Menu_SetRVerticalOffset:
	InputBox, newOfs, Set Vertical Offset, Enter an integer between -9999-9999,,,,,,,,%cross_rOffset_Y%
	if (ErrorLevel == 0)
		if newOfs is integer
			cross_rOffset_Y := newOfs < -9999 ? -9999
					: newOfs > 9999 ? 9999
					: newOfs
	IniWrite, %cross_rOffset_Y%, crosshair.ini, Startup, cross_rOffset_Y
return

Menu_ToggleExcludeMode:
	mExcludeMode := mExcludeMode ? False : True
	IniWrite, %mExcludeMode%, crosshair.ini, Startup, ExcludeMode
	if (m_ExcludeMode)
		TrayTip, Crosshair, Crosshair will show unless hooked apps are active.
	else
		TrayTip, Crosshair, Crosshair will only show if hooked apps are active.
		
	Gosub UpdateMenu
	Reload
return

Menu_SetOpacity:
	InputBox, newAlpha, Set Crosshair Opacity, Enter an integer between 1-255,,,,,,,,%mAlpha%
	if (ErrorLevel == 0)
		if newAlpha is integer
			mAlpha := newAlpha < 1 ? 1
					: newAlpha > 255 ? 255
					: newAlpha
	IniWrite, %mAlpha%, crosshair.ini, Startup, Opacity
return

Menu_SetColour:
	pColor := ChooseColor(mRGBColor, , 100, 100, Colors*)
	mRGBColor := Format("{1:#x}", pColor)
	IniWrite, %mRGBColor%, crosshair.ini, Startup, RGBColor
return

Menu_SetThickness:
	InputBox, newThickness, Set Crosshair Thickness, Enter an integer between 1-64`n,,,,,,,,%mThickness%
	if (ErrorLevel == 0)
		if newThickness is integer
		{
			mThickness := newThickness < 1 ? 1
					: newThickness > 64 ? 64
					: newThickness
			IniWrite, %mThickness%, crosshair.ini, Startup, Thickness
			gosub crosshairDestroy
			SetTimer, crosshair, 1
		}
return

Menu_SetInvert:
	mInvert := mInvert ? 0 : 1
	
	IniWrite, %mInvert%, crosshair.ini, Startup, Invert
	if (mInvert)
		TrayTip, Crosshair, Cursor will use inverted colour under cursor (WARNING SLOW IN AERO).
	else
		TrayTip, Crosshair, Cursor will use fixed colour.
	
	Gosub UpdateMenu
return

Menu_SetCursorTrail:
	mCursorTrail := mCursorTrail ? 0 : 1

	IniWrite, %mCursorTrail%, crosshair.ini, Startup, CursorTrail
	if (mCursorTrail)
	{
		Gosub PTrail_Enable
		TrayTip, Crosshair, Cursor Trail ACTIVE.
	}
	else
	{
		Gosub PTrail_Disable
		TrayTip, Crosshair, Cursor Trail DISABLED.
	}

	Gosub UpdateMenu
return

Menu_ToggleProgram:
	TrayTip, Crosshair, Click on any window to enable/disable the crosshair for it.

WaitForWin:
	WinGetClass, WinClass, A
	if (WinClass == "") {
		sleep, 100
		Goto, WaitforWin
	}
	TrayTip

	; Check to see if app is already handled by crosshair
	AppDisable := False
	Loop, %NumApps%
	{
		IniRead, AppName, crosshair.ini, Apps, %A_Index%
		if (AppName == WinClass && !AppDisable)
		{
			MsgBox, 0x4, Crosshair, Want to disable the crosshair for %WinClass%?
			IfMsgBox, Yes 
			{
				AppDisable := True
				TrayTip, Crosshair, Crosshair has been disabled for %WinClass%! Restarting...
			} else {
				TrayTip, Crosshair, For a second there`, I thought you didn't like me.
				return
			}
		}
		else if (AppDisable)
		{
			; tidy up the app list
			AppIndex := A_Index - 1
			IniWrite, %AppName%, crosshair.ini, Apps, %AppIndex%
		}
	}
	
	if (AppDisable)
	{
		NewNumApps := NumApps - 1
		IniWrite, %NewNumApps%, crosshair.ini, Startup, Num_Apps
		
		; remove the last entry
		if (NewNumApps < 1)
			IniDelete, crosshair.ini, Apps
		else
			IniDelete, crosshair.ini, Apps, %NumApps%
		; have to reload since there's no way to remove apps from a group while the script is active
		Reload
		return
	}
	if (mExcludeMode)
		MsgBox, 0x4, Crosshair, Do you want to hide the crosshair when %WinClass% is active?
	else
		MsgBox, 0x4, Crosshair, Do you want to show the crosshair when %WinClass% is active?
		
	IfMsgBox, Yes 
	{
		NumApps++
		GroupAdd, CrossWinGroup, ahk_class %WinClass%
		IniWrite, %NumApps%, crosshair.ini, Startup, Num_Apps
		IniWrite, %WinClass%, crosshair.ini, Apps, %NumApps%
		TrayTip, Crosshair, Crosshair enabled for %WinClass%!
	} else {
		TrayTip, Crosshair, Hooking Canceled!
	}
return

About:
	Msgbox, 131393, Crosshair %Version% by MOAT Digital Design inc., Thank you for using Crosshair!`nIf you like this utility, consider making a donation (hit OK to visit the donation page).`n`nSpecial thanks to tic for the GDI+ libraries and to Chris Mallett for creating Autohotkey.
	IfMsgBox, OK
	{
		TrayTip, Crosshair, You are awesome for doing this. Did you know that?
		Run, https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=KTLW5HM4P9QDC
	}
return

Help:
	Run, http://www.youtube.com/watch?v=iFlLWkD0H8I
return

; ===============================================================================
; END OF Menu Functions
; ===============================================================================

crosshairDestroy:
	if (mDisabled && xDisabled && rDisabled && !mActive)
		SetTimer, crosshair, Off
		
	GoSub crosshairErase
	HideGDI(hCross)
	HideGDI(vCross)
	HideGDI(xCross)
	HideGDI(rCross)
	HideGDI(wCross)
return

crosshairErase:
	EraseGDI(hCross)
	EraseGDI(vCross)
	EraseGDI(xCross)
	EraseGDI(rCross)
	EraseGDI(wCross)
return

CheckMon:
	SysGet, MonCt, MonitorCount

	mWidth := 0
	mHeight := 0
	mLeft := 0
	mTop := 0
	mRight := 0
	mBottom := 0
	oMon := -255 ; force refresh
	
	Loop %MonCt%  ; Query each monitor, also get size of largest monitor
	{
		SysGet, Mon%A_Index%, Monitor, %A_Index%
		mWidth := (Mon%A_Index%Right - Mon%A_Index%Left) > mWidth ? Mon%A_Index%Right - Mon%A_Index%Left : mWidth
		mHeight := (Mon%A_Index%Bottom - Mon%A_Index%Top) > mHeight ? Mon%A_Index%Bottom - Mon%A_Index%Top : mHeight
	}
return

crosshair:
	if (mDisabled && xDisabled) {
		gosub crosshairDestroy
		return
	}
	
	MouseGetPos, MX, MY
	
	sniperMode := !rDisabled && rActive && mCentered

	Loop %MonCt%  ; Find which monitor we are on
	{
		if (MX >= Mon%A_Index%Left && MX <= Mon%A_Index%Right && MY >= Mon%A_Index%Top && MY <= Mon%A_Index%Bottom) {
			mon := A_Index
			break
		}
	}
	
	if (mon != oMon) 
	{
		mLeft := Mon%mon%Left
		mTop := Mon%mon%Top
		mRight := Mon%mon%Right
		mBottom := Mon%mon%Bottom
		oMon := Mon
	}
	
	SetFormat, IntegerFast, hex
	mBaseColor := mRGBColor
	
	if (mInvert)
		PixelGetColor, pColor, MX, MY, RGB
	else
		pColor := mBaseColor
		
	if (mInvert)
	{
		red := pColor >> 16
		pColor -= red << 16
		grn := pColor >> 8
		pColor -= grn << 8
		blu := pColor
	
		red := 0x7F - red
		red := (red < 0x40 && red > 0) ? 0x7F + 0x40 + red
				: (red > -0x40 && red < 0) ? 0x7F - 0x40 - red
				: 0x80 + red
		grn := 0x7F - grn
		grn := (grn < 0x40 && grn > 0) ? 0x7F + 0x40 + grn
				: (grn > -0x40 && grn < 0) ? 0x7F - 0x40 - grn
				: 0x80 + grn
		blu := 0x7F - blu
		blu := (blu < 0x40 && blu > 0) ? 0x7F + 0x40 + blu
				: (blu > -0x40 && blu < 0) ? 0x7F - 0x40 - blu
				: 0x80 + blu
		pColor := "0x" . (red <= 0xF ? 0 : "") . SubStr(red, 3) . (grn <= 0xF ? 0 : "") . SubStr(grn, 3) . (blu <= 0xF ? 0 : "") . SubStr(blu, 3)
	}
	
	SetFormat, Integer, d

	if (mCentered)
	{
		MX := (mLeft + mRight) * 0.5
		MY := (mTop + mBottom) * 0.5
	}
	
	if (!sniperMode)
	{
		MX := MX + cross_Offset_X
		MY := MY + cross_Offset_Y
	}
	else
	{
		MX := MX + cross_Offset_X + sniperOffsetX
		MY := MY + cross_Offset_Y + sniperOffsetY
	}
	

	
	if (g_isDirty || oMX != MX || oMY != MY || oPColor != pColor || (!rDisabled && rActive && rCross.isDirty)) 
	{
		g_isDirty := False
		mPen:=Gdip_CreatePen(((255)<<24)+pColor, mThickness)

; Horizontal
		if (!mDisabled)
		{
			if (hCross.isDirty)
			{
				Gdip_DrawLine(hCross.G, mPen, 0, 0, mRight-mLeft,0)
				hCross.isDirty := false
			}
			UpdateLayeredWindow(hCross.hWnd, hCross.hdc, mLeft, MY - (mThickness * 0.25), mRight-mLeft, mThickness, mAlpha)
			
	; Vertical
			if (vCross.isDirty)
			{
				if (!sniperMode)
					Gdip_DrawLine(vCross.G, mPen, 0, 0, 0,mBottom-mTop)
				else
					HideGDI(vCross)
				vCross.isDirty := false
			}
			UpdateLayeredWindow(vCross.hWnd, vCross.hdc, MX - (mThickness * 0.25), mTop, mThickness, mBottom-mTop, mAlpha)
		}
		

; X CROSSHAIR
		if (!xDisabled)
		{
			if (xCross.isDirty)
			{
				Gdip_DrawLine(xCross.G, mPen, 0, 0, xCross.Width,xCross.Height)
				Gdip_DrawLine(xCross.G, mPen, 0, xCross.Height, xCross.Width, 0)
				xCross.isDirty := False
			}
			
			UpdateLayeredWindow(xCross.hWnd, xCross.hdc, MX - (xCross.Width * 0.5) - mThickness*0.25, MY - (xCross.Height * 0.5)-mThickness*0.25, xCross.Width, xCross.Height, mAlpha * (mDisabled ? 1 : 0.5))
		}

; R CROSSHAIR (Angle Line)

		if (!rDisabled && (rActive || !mCentered))
		{
			screenCenterX := (mRight + mLeft) * 0.5 
			screenCenterY := (mBottom + mTop) * 0.5 - cross_rOffset_Y
						
			if (mCentered)
			{

				if (rCross.isDirty)
				{
					EraseGDI(rCross)
					if (captureMouse)
					{						
						mSensitivity := 1
						rZeroIncr -= mouseDeltaY * mSensitivity
						mouseDeltaX := 0
						mouseDeltaY := 0
						if (rZeroIncr > 99)
						{
							if (rZero < 5)
								rZeroIncr -= 100
							rZero += 1
							rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
							Send, {x}
						}
						else if (rZeroIncr < -25)
						{
							if (rZero > 0)
								rZeroIncr += 100
							
							rZero -= 1
							rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
							Send, {z}
						}
						rZeroIncr := rZero == 5 && rZeroIncr > 100 ? 100 : rZeroIncr
						rZeroIncr := rZero == 0 && rZeroIncr < 0 ? 0 : rZeroIncr
						; rZero 
						; rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
						; tooltip %mouseDeltaX% %mouseDeltaY%
					}
					
					rMagnification := 2.0
					rElevationUnit := 21
					
					; rZeroOffset := rZero * rElevationUnit * rMagnification
					rZeroOffset := 0.5 * rElevationUnit * rMagnification
					
					Gdip_DrawLine(rCross.G, mPen, rCross.Width * 0.5, 0, rCross.Width * (0.5 + rOffset), rCross.Height)

					
					Loop, 9
					{
						rIndex := A_Index - 1
						rSubTic := rIndex * 0.25
						ticY := 1 + rElevationUnit * rMagnification * rSubTic
						ticX := rCross.Width * (0.5 + rOffset * (rMagnification * rSubTic * rElevationUnit / rCross.Height))
						ticWidth := Abs(Mod(rIndex, 4)) == 0 ? 5 : Abs(Mod(rIndex, 2)) == 0 ? 10 : 2.5
						Gdip_DrawLine(rCross.G, mPen, ticX - ticWidth, ticY, ticX + ticWidth, ticY)
					}
					rSubTic := -0.5
					rXOffset := rCross.Width * (rOffset * (rMagnification * rSubTic * rElevationUnit / rCross.Height))
					rYOffset := rElevationUnit * rMagnification * rSubTic

;					Gdip_DrawLine(rCross.G, mPen, rCross.Width * (0.5 + 0.5 * rOffset), 0, rCross.Width * (0.5 + 0.5 * rOffset), 16)
					rCross.isDirty := False

					pBrushBG := Gdip_BrushCreateSolid(0xAf000000)
					Gdip_FillRectangle(rCross.G, pBrushBG, 65, 0,  35, 16)
					Gdip_DeleteBrush(pBrushBG)
					
					GDIPrintString( rCross, Round(100*rZero + rZeroIncr), 0, 0, "ffff00ff")
					
;					UpdateLayeredWindow(rCross.hWnd, rCross.hdc, cross_Offset_X + screenCenterX - (rCross.Width * 0.5) - mThickness*0.25 + rXOffset, cross_Offset_Y + screenCenterY-mThickness*0.25 - rZeroOffset + rYOffset, rCross.Width, rCross.Height, mAlpha * (mDisabled ? 1 : 0.5))
					sniperOffsetX := rCross.Width * (rOffset * (rMagnification * (rZero + (rZeroIncr * 0.01)) * rElevationUnit / rCross.Height))
					sniperOffsetY := rElevationUnit * rMagnification * (rZeroIncr * 0.01)
					
					UpdateLayeredWindow(rCross.hWnd, rCross.hdc, cross_Offset_X + screenCenterX - (rCross.Width * 0.5) - mThickness*0.25 + rXOffset + sniperOffsetX, cross_Offset_Y + screenCenterY-mThickness*0.25 - rZeroOffset + sniperOffsetY, rCross.Width, rCross.Height, mAlpha * (mDisabled ? 1 : 0.5))

					
					windStrength := 125
					windMeterYOffset := 225
					Gdip_DrawLine(wCross.G, mPen, wCross.Width * 0.5, 0, 0, wCross.Height)
					Gdip_DrawLine(wCross.G, mPen, wCross.Width * 0.5, 0, wCross.Width, wCross.Height)
					
					wCross.isDirty := False
					
					
					UpdateLayeredWindow(wCross.hWnd, wCross.hdc, cross_Offset_X + screenCenterX - (wCross.Width * 0.5) - mThickness*0.25 + windStrength * rOffset, cross_Offset_Y + windMeterYOffset-mThickness*0.25, wCross.Width, wCross.Height, mAlpha * (mDisabled ? 1 : 0.5))
				}
			}
			else
			{
				screenHalfHeight := (mBottom - mTop) * 0.5
				
				screenCenterToCursorDeltaX := MX - screenCenterX
				screenCenterToCursorDeltaY := MY - screenCenterY
				
				screenCenterToCursorDistance := clamp(0, screenHalfHeight, mag(screenCenterToCursorDeltaX, screenCenterToCursorDeltaY)) * 2
				lineCursorLength := iLerp(0, screenHalfHeight * 2, screenCenterToCursorDistance) * rCross.Width
				
				lineCursorDeltaX := screenCenterToCursorDeltaX
				lineCursorDeltaY := screenCenterToCursorDeltaY
				normalize(lineCursorDeltaX, lineCursorDeltaY, lineCursorLength)
				rCrossCenter := rCross.Width * 0.5
				
				EraseGDI(rCross)
				
				rCrossDeltaX := lineCursorDeltaX * 0.5
				rCrossDeltaY := lineCursorDeltaY * 0.5
				
				Gdip_DeletePen(mPen)
				mPen:=Gdip_CreatePen(((255)<<24)+pColor, mThickness + 2)
				
				Gdip_DrawLine(rCross.G, mPen, rCrossCenter - rCrossDeltaX, rCrossCenter - rCrossDeltaY, rCrossCenter + rCrossDeltaX, rCrossCenter + rCrossDeltaY)
				
				Gdip_DeletePen(mPen)
				mPen:=Gdip_CreatePen(((255)<<24)+invertColor(pColor), mThickness)
				Gdip_DrawLine(rCross.G, mPen, rCrossCenter - rCrossDeltaX, rCrossCenter - rCrossDeltaY, rCrossCenter + rCrossDeltaX, rCrossCenter + rCrossDeltaY)

				UpdateLayeredWindow(rCross.hWnd, rCross.hdc, MX - (rCross.Width * 0.5) - mThickness*0.25, MY - (rCross.Height * 0.5)-mThickness*0.25, rCross.Width, rCross.Height, mAlpha)
			}
		}

		Gdip_DeletePen(mPen)
		
		screenCenterMag := mag(MX - screenCenterX, MY - screenCenterY)
		
		
		oMX := MX
		oMY := MY
		oPColor := pColor
	}
return


; =======================
; PAPER TRAIL
; =======================

PTrail_Enable:
	SetTimer, PTrail_Draw, 5 ; the faster this one is, the smaller the groups of lines are faded out
	SetTimer, PTrail_Fade, 100 ; the faster this one is, the smaller the groups of lines are faded out
	SetTimer, PTrail_Update, 40 ; the faster this one is, the more frequently the image is updated
	UpdateLayeredWindow(ptrail_hWnd, ptrail_hdc, 0, 0, 1, 1, 0)
return

PTrail_Disable:
	SetTimer, PTrail_Draw, off ; the faster this one is, the smaller the groups of lines are faded out
	SetTimer, PTrail_Fade, off ; the faster this one is, the smaller the groups of lines are faded out
	SetTimer, PTrail_Update, off ; the faster this one is, the more frequently the image is updated
	UpdateLayeredWindow(ptrail_hWnd, ptrail_hdc, 0, 0, 1, 1, 0)
return

; ~*LButton::
; 	GetKeyState, LBUT, LButton, P
; 	SetTimer, CheckLButton, 10 ; stop polling L1
; return

CheckLButton:
	GetKeyState, LBUT, LButton, P
	if (LBUT == "U")
		SetTimer, CheckLButton, off ; stop polling L1
return

PTrail_Draw:
	GetKeyState, SpaceState, Alt
	if (SpaceState == "D")
	{
		pTrail_isDirty := True
		pTrail_needsUpdate := True
		return
	}
	if (LBUT == "D")
		return
	
	; auto scrolling
	pTrail_oX := pTrail_X
	pTrail_oY := pTrail_Y
	MouseGetPos, pTrail_X, pTrail_Y
	if (pTrail_X == pTrail_oX && pTrail_Y == pTrail_oY)
		return
		
	oldOfsX := ptrail_ofsX
	oldOfsY := ptrail_ofsY
	ptrail_ofsX := pTrail_X < ptrail_ofsX ? pTrail_X : pTrail_X >= ptrail_ofsX + ptrail_width ? pTrail_X - ptrail_width + 1: ptrail_ofsX
	ptrail_ofsY := pTrail_Y < ptrail_ofsY ? pTrail_Y : pTrail_Y >= ptrail_ofsY + ptrail_height ? pTrail_Y - ptrail_height + 1 : ptrail_ofsY
	if (oldOfsX != ptrail_ofsX || oldOfsY != ptrail_ofsY)
	{
		BitBlt(ptrail_hdc, oldOfsX - ptrail_ofsX, oldOfsY - ptrail_ofsY, ptrail_width, ptrail_height, ptrail_hdc, 0, 0,"")
		; erase the recently vacated area
		pBrushClear := Gdip_BrushCreateSolid(0x00000000)
		if (pTrail_ofsX < oldOfsX) ; erase left side
			Gdip_FillRectangle(ptrail_G, pBrushClear, 0, 0,  oldOfsX - ptrail_ofsX, ptrail_height)
		else if (pTrail_ofsX > oldOfsX) ; erase right side
			Gdip_FillRectangle(ptrail_G, pBrushClear, ptrail_width - (ptrail_ofsX - oldOfsX), 0, ptrail_ofsX - oldOfsX, ptrail_height)
			
		if (pTrail_ofsY < oldOfsY) ; erase top
			Gdip_FillRectangle(ptrail_G, pBrushClear, 0, 0,  ptrail_width, oldOfsY - ptrail_ofsY)
		else if (pTrail_ofsY > oldOfsY) ; erase bottom
			Gdip_FillRectangle(ptrail_G, pBrushClear, 0, ptrail_height - (ptrail_ofsY - oldOfsY), ptrail_width, ptrail_ofsY - oldOfsY)
			
		Gdip_DeleteBrush(pBrushClear)
		ptrail_r1 += oldOfsX - ptrail_ofsX
		ptrail_r2 += oldOfsY - ptrail_ofsY
		pTrail_isDirty := True
		pTrail_needsUpdate := True
	}
	
	ptrail_r3 := ptrail_r1
	ptrail_r4 := ptrail_r2
	ptrail_r1 := pTrail_X-ptrail_ofsX
	ptrail_r2 := pTrail_Y-ptrail_ofsY
	; add a new line
	ptBaseColor  := 0xff40C0ff
	ptPen:=Gdip_CreatePen(ptBaseColor, 1)
	Gdip_DrawLine(ptrail_G, ptPen,ptrail_r1,ptrail_r2,ptrail_r3,ptrail_r4)
	Gdip_DeletePen(ptPen)

	pTrail_isDirty := True
	pTrail_needsUpdate := True
Return

PTrail_Fade:
	if (!pTrail_isDirty)
		return
		
	fadeRate := -0.1
	; fade the drawing
	if (SpaceState == "D")
	{
		Matrix =
		( LTrim Join
			1|0|0|0.25|0|
			0|1|0|0.75|0|
			0|0|1|1|0|
			0|0|0|0|0|
			-0.1|-0.1|-0.1|0|1
		)
	}	
	else
	{
		Matrix =
		( LTrim Join
			1|0|0|0.25|0|
			0|1|0|0.75|0|
			0|0|1|1|0|
			0|0|0|0|0|
			%fadeRate%|%fadeRate%|%fadeRate%|0|1
		)
	}	
	pTrail_bitmap := Gdip_CreateBitmapFromHBITMAP(ptrail_hbm)
	Gdip_DrawImage(ptrail_G, pTrail_bitmap,"","","","","","","","",Matrix)
	Gdip_DisposeImage(pTrail_bitmap)
	pTrail_isDirty := False
Return

PTrail_Update:
	if (!pTrail_needsUpdate)
		return
		
	UpdateLayeredWindow(ptrail_hWnd, ptrail_hdc, ptrail_ofsX, ptrail_ofsY, ptrail_width, ptrail_height, 255)
	pTrail_needsUpdate := False
	
Return

~RButton::
	if (!mCentered)
		return
	rActive := true
	EraseGDI(rCross)
	EraseGDI(wCross)
return

~RButton up::
	if (!mCentered)
		return
	rActive := false
	HideGDI(rCross)
	HideGDI(wCross)
return

~RButton & ~WheelUp::
	if (!mCentered)
		return
		
	if (GetKeyState("Control"))
	{
		rZeroIncr++
		if (rZeroIncr > 75)
		{
			if (rZero < 5)
				rZeroIncr -= 100
			rZero += 1
			rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
			Send, {x}
		}
		else if (rZeroIncr < -75)
		{
			if (rZero > 0)
				rZeroIncr += 100
			
			rZero -= 1
			rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
			Send, {z}
		}
		rZeroIncr := rZero == 5 && rZeroIncr > 100 ? 100 : rZeroIncr
		rZeroIncr := rZero == 0 && rZeroIncr < 0 ? 0 : rZeroIncr
	}
	else
	{
		rOffset := rOffset - 0.01
		rOffset := rOffset < -1 ? -1 : rOffset
	}
		
		
	EraseGDI(rCross)
	EraseGDI(wCross)
return

~RButton & ~WheelDown::
	if (!mCentered)
		return
		
	if (GetKeyState("Control"))
	{
		rZeroIncr--
		if (rZeroIncr > 99)
		{
			if (rZero < 5)
				rZeroIncr -= 100
			rZero += 1
			rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
			Send, {x}
		}
		else if (rZeroIncr < -25)
		{
			if (rZero > 0)
				rZeroIncr += 100
			
			rZero -= 1
			rZero := rZero < 0 ? 0 : rZero > 5 ? 5 : rZero
			Send, {z}
		}
		rZeroIncr := rZero == 5 && rZeroIncr > 100 ? 100 : rZeroIncr
		rZeroIncr := rZero == 0 && rZeroIncr < 0 ? 0 : rZeroIncr
	}
	else
	{
		rOffset := rOffset + 0.01
		rOffset := rOffset > 1 ? 1 : rOffset
	}
	
	EraseGDI(rCross)
	EraseGDI(wCross)
return

~RButton & ~MButton::
	if (!mCentered)
		return
	if (GetKeyState("Control"))
		rZeroIncr := 0
	else
		rOffset := 0
	EraseGDI(rCross)
return


~RButton & ~x::
	if (!mCentered)
		return
	rZero := rZero + 1
	rZero := rZero > 5 ? 5 : rZero
	EraseGDI(rCross)
	EraseGDI(wCross)
return

~RButton & ~z::
	if (!mCentered)
		return
	rZero := rZero - 1
	rZero := rZero < 0 ? 0 : rZero
	if (rZero == 0 && rZeroIncr < 0)
		rZeroIncr += 100
	EraseGDI(rCross)
	EraseGDI(wCross)
return

~Ctrl & ~RButton::
~RButton & ~Ctrl::
	captureMouse := !rDisabled && rActive && mCentered
return

~Ctrl & ~RButton Up::
~RButton & ~Ctrl Up::
	captureMouse := !mCentered
	mouseDeltaX := 0
	mouseDeltaY := 0
return

UpdateMenu:
	if (mInvert)
	{
		Menu, tray, Check, Use Invert Colour
		Menu, tray, Disable, Set Crosshair Colour
	}
	else
	{
		Menu, tray, UnCheck, Use Invert Colour
		Menu, tray, Enable, Set Crosshair Colour
	}
	
	if (mDisabled)
		Menu, tray, UnCheck, Show Crosshair
	else
		Menu, tray, Check, Show Crosshair

	if (xDisabled)
		Menu, tray, UnCheck, Show X-Crosshair
	else
		Menu, tray, Check, Show X-Crosshair

	if (rDisabled)
		Menu, tray, UnCheck, Show R-Crosshair
	else
		Menu, tray, Check, Show R-Crosshair
		
	if (mCentered)
		Menu, tray, Check, Centered Crosshair
	else
		Menu, tray, UnCheck, Centered Crosshair
		
	if (mExcludeMode)
		Menu, tray, Check, Exclude Mode
	else
		Menu, tray, UnCheck, Exclude Mode
		
	if (mCursorTrail)
		Menu, tray, Check, Show Cursor Trail
	else
		Menu, tray, UnCheck, Show Cursor Trail
return

; ==========================================================
; HOTKEY CUSTOMIZATION
; ==========================================================

Menu_SetToggleHotkeyWindow:
		
	if (ToggleMouseButton != "" && ToggleMouseButton != "Hotkey")
	{
		keyTmp := "~" . ToggleMouseButton
		Hotkey, %keyTmp%, ToggleCrosshair, Off
		Hotkey, %keyTmp% Up, ToggleCrosshair, Off
		
		keyTmp := "~*" . ToggleMouseButton
		Hotkey, %keyTmp%, ToggleCrosshair, Off
		Hotkey, %keyTmp% Up, ToggleCrosshair, Off
	}
	else if (toggleHotkey != "")
		Hotkey, %toggleHotkey%, ToggleCrosshair, Off

	ChosenHotkey := toggleHotkey

	Gui, HotkeyWin: +OwnDialogs
	Gui, HotkeyWin: Add, Text,, Choose a key combination`nto toggle the crosshair:
	
	DDLChooser := ToggleMouseButton == "LButton" ? 2 : ToggleMouseButton == "RButton" ? 3 : ToggleMouseButton == "MButton" ? 4 : 1

	Gui, HotkeyWin: Add, DropDownList, vToggleMouseButton Choose%DDLChooser%, Hotkey|LButton|RButton|MButton
	Gui, HotkeyWin: Add, Hotkey, vChosenHotkey, %toggleHotkey%
		
	Gui, HotkeyWin: Add, Checkbox, vToggleHotkeyX, Toggle X Crosshair

	Gui, HotkeyWin: Add, Button, Default, OK
	Gui, HotkeyWin: Show
return


HotkeyWinButtonOK:
	Gui, HotkeyWin: Submit

	if (ToggleMouseButton != "" && ToggleMouseButton != "Hotkey")
	{
		keyTmp := "~" . ToggleMouseButton
		Hotkey, %keyTmp%, ToggleCrosshair, On
		Hotkey, %keyTmp% Up, ToggleCrosshair, On
		
		keyTmp := "~*" . ToggleMouseButton
		Hotkey, %keyTmp%, ToggleCrosshair, On
		Hotkey, %keyTmp% Up, ToggleCrosshair, On
	}
	else if (ChosenHotkey != "")
	{
		toggleHotkey := ChosenHotkey
		Hotkey, %toggleHotkey%, ToggleCrosshair, On
	}
	
	IniWrite, %ToggleMouseButton%, crosshair.ini, Startup, ToggleMouseButton
	IniWrite, %toggleHotkey%, crosshair.ini, Startup, Toggle_Hotkey
	IniWrite, %ToggleHotkeyX%, crosshair.ini, Startup, Toggle_HotkeyX
	Gui, HotkeyWin: Destroy

return

ToggleCrosshair:
	g_isDirty := True
	if (ToggleHotkeyX)
		gosub Menu_ToggleXCrosshair
		
	gosub Menu_ToggleCrosshair
return


; uncomment if gdip is not in ur standard library
; #include gdip.ahk

Quit:
AppQuit:
	if (GDILoaded)
	{
		Gdip_Shutdown(pToken)
		GDIEnd()
	}
	
	ExitApp
return

CreateGDI(ObjName, ObjWidth, ObjHeight)
{
	global 

	%ObjName% := Object()
	GDI_Target := %ObjName%
	
	GNum++
	GDI_Target.GDIndex := GNum
	
	Gui, %GNum%: -Caption +E0x80000 +E0x20 +LastFound +AlwaysOnTop +ToolWindow +OwnDialogs
	Gui, %GNum%: Show, NA
	GDI_Target.hWnd := WinExist()

	GDI_Target.Width := ObjWidth
	GDI_Target.Height := ObjHeight
	
	GDI_Target.hbm := CreateDIBSection(GDI_Target.Width, GDI_Target.Height)
	GDI_Target.hdc := CreateCompatibleDC()
	GDI_Target.obm := SelectObject(GDI_Target.hdc, GDI_Target.hbm)
	GDI_Target.G := Gdip_GraphicsFromHDC(GDI_Target.hdc)

	Gdip_SetSmoothingMode(GDI_Target.G, 3)
	Gdip_SetCompositingMode(GDI_Target.G, 1)              ; set overdraw
	Gdip_SetInterpolationMode(GDI_Target.G, 1)	 ; lo quality
	
	GDI_Target.isDirty := True
	
	%ObjName% := GDI_Target
	
}

EraseGDI(GDI_Target)
{
	global

	eraseBrush := Gdip_BrushCreateSolid(0x00000000) ; fully transparent brush 'eraser'
	Gdip_FillRectangle(GDI_Target.G, eraseBrush, 0, 0, GDI_Target.Width, GDI_Target.Height)
	Gdip_DeleteBrush(eraseBrush)
	GDI_Target.isDirty := True
}


HideGDI(GDI_Target)
{
	global
	UpdateLayeredWindow(GDI_Target.hWnd, GDI_Target.hdc, 0, 0, 1, 1, 0)
	GDI_Target.isDirty := True
}


atan2(y, x) {	; 4-quadrant atan
   Return dllcall("msvcrt\atan2","Double",y, "Double",x, "CDECL Double")
}

dtr(x){
   global pi
   return (x * pi / 180)
}

rtd(x){
   global pi
   return (x * 180 / pi)
}  

Lerp(Min, Max, Amount)
{
	result := Min + (Max - Min) * Amount
	result < Min ? Min : result > Max ? Max : result
	return result
}

iLerp(a,b,t)
{
	result := (t - a) / (b - a)
	return result
}

mag(a, b) ; return magnitude of a vector
{
	return (a**2+b**2)**0.5
}

normalize(ByRef a, ByRef b, radius = 1)
{
	len := mag(a,b)
	a := ((a * radius) / len)
	b := ((b * radius) / len)
}

clamp(a, b, t)
{
	return t < a ? a : t > b ? b : t
}

GDIPrintString( GDI_Target, str, x, y, argb = "ffffffff")
{
	Options = x%x%p y%y%p w80p Centre c%argb% r1 s12 Bold
	Gdip_TextToGraphics(GDI_Target.G, str, Options, "Consolas", GDI_Target.Width, GDI_Target.Height)
}

GDIBegin()
{
	global pToken
	If !pToken := Gdip_Startup(){
		MsgBox, 48, gdiplus error!, Gdiplus failed to start. Please ensure you have gdiplus on your system
		ExitApp
	}
	
	GDILoaded := True
}

GDIEnd()
{
}

invertColor(pColor)
{
	SetFormat, IntegerFast, hex
	red := pColor >> 16
	pColor -= red << 16
	grn := pColor >> 8
	pColor -= grn << 8
	blu := pColor

	red := 0x7F - red
	red := (red < 0x40 && red > 0) ? 0x7F + 0x40 + red
			: (red > -0x40 && red < 0) ? 0x7F - 0x40 - red
			: 0x80 + red
	grn := 0x7F - grn
	grn := (grn < 0x40 && grn > 0) ? 0x7F + 0x40 + grn
			: (grn > -0x40 && grn < 0) ? 0x7F - 0x40 - grn
			: 0x80 + grn
	blu := 0x7F - blu
	blu := (blu < 0x40 && blu > 0) ? 0x7F + 0x40 + blu
			: (blu > -0x40 && blu < 0) ? 0x7F - 0x40 - blu
			: 0x80 + blu
	pColor := "0x" . (red <= 0xF ? 0 : "") . SubStr(red, 3) . (grn <= 0xF ? 0 : "") . SubStr(grn, 3) . (blu <= 0xF ? 0 : "") . SubStr(blu, 3)
	
	SetFormat, Integer, d

	return pColor
}

InputMsg(wParam, lParam) 
{
;    Local r, h, v
    global RIM_TYPEMOUSE, mouseDeltaX, mouseDeltaY, captureMouse, II_MSE_LASTX, II_MSE_LASTY, rCross
    Critical    ;Or otherwise you could get ERROR_INVALID_HANDLE
    
	if (!captureMouse)
		return
		
    ;Get device type
    r := AHKHID_GetInputInfo(lParam, II_DEVTYPE) 
    If (r == RIM_TYPEMOUSE) 
	{
        mouseDeltaX += AHKHID_GetInputInfo(lParam, II_MSE_LASTX)
        mouseDeltaY += AHKHID_GetInputInfo(lParam, II_MSE_LASTY)
		rCross.isDirty := true
	}	
;        GuiControl,, lbxInput, % ""
;        . " Flags: "       AHKHID_GetInputInfo(lParam, II_MSE_FLAGS) 
;        . " ButtonFlags: " AHKHID_GetInputInfo(lParam, II_MSE_BUTTONFLAGS) 
;        . " ButtonData: "  AHKHID_GetInputInfo(lParam, II_MSE_BUTTONDATA) 
;        . " RawButtons: "  AHKHID_GetInputInfo(lParam, II_MSE_RAWBUTTONS) 
;        . " LastX: "       AHKHID_GetInputInfo(lParam, II_MSE_LASTX)
;        . " LastY: "       AHKHID_GetInputInfo(lParam, II_MSE_LASTY) 
;        . " ExtraInfo: "   AHKHID_GetInputInfo(lParam, II_MSE_EXTRAINFO) ;%
;    } Else If (r = RIM_TYPEKEYBOARD) {
;        GuiControl,, lbxInput, % ""
;        . " MakeCode: "    AHKHID_GetInputInfo(lParam, II_KBD_MAKECODE)
;        . " Flags: "       AHKHID_GetInputInfo(lParam, II_KDB_FLAGS)
;        . " VKey: "        AHKHID_GetInputInfo(lParam, II_KBD_VKEY)
;        . " Message: "     AHKHID_GetInputInfo(lParam, II_KBD_MSG) 
;        . " ExtraInfo: "   AHKHID_GetInputInfo(lParam, II_KBD_EXTRAINFO)    ;%
;    } Else If (r = RIM_TYPEHID) {
;        h := AHKHID_GetInputInfo(lParam, II_DEVHANDLE)
;        r := AHKHID_GetInputData(lParam, uData)
;		v := AHKHID_GetDevInfo(h, DI_HID_VENDORID,     True)
;		if (v != 57005 && v != 26214)
;		{
;			GuiControl,, lbxInput, % ""
;			. " Vendor ID: "   v
;			. " Product ID: "  AHKHID_GetDevInfo(h, DI_HID_PRODUCTID,    True)
;			. " Data: " Bin2Hex(&uData, r)
;		}
;    }


    SendMessage, 0x018B, 0, 0,, ahk_id %hlbxInput%
    SendMessage, 0x0186, ErrorLevel - 1, 0,, ahk_id %hlbxInput%

}

;By Laszlo
;http://www.autohotkey.com/forum/viewtopic.php?p=135522#135522
Bin2Hex(addr,len) {
    Static fun, ptr 
    If (fun = "") {
        If A_IsUnicode
            If (A_PtrSize = 8)
                h=4533c94c8bd14585c07e63458bd86690440fb60248ffc2418bc9410fb6c0c0e8043c090fb6c00f97c14180e00f66f7d96683e1076603c8410fb6c06683c1304180f8096641890a418bc90f97c166f7d94983c2046683e1076603c86683c13049ffcb6641894afe75a76645890ac366448909c3
            Else h=558B6C241085ED7E5F568B74240C578B7C24148A078AC8C0E90447BA090000003AD11BD2F7DA66F7DA0FB6C96683E2076603D16683C230668916240FB2093AD01BC9F7D966F7D96683E1070FB6D06603CA6683C13066894E0283C6044D75B433C05F6689065E5DC38B54240833C966890A5DC3
        Else h=558B6C241085ED7E45568B74240C578B7C24148A078AC8C0E9044780F9090F97C2F6DA80E20702D1240F80C2303C090F97C1F6D980E10702C880C1308816884E0183C6024D75CC5FC606005E5DC38B542408C602005DC3
        VarSetCapacity(fun, StrLen(h) // 2)
        Loop % StrLen(h) // 2
            NumPut("0x" . SubStr(h, 2 * A_Index - 1, 2), fun, A_Index - 1, "Char")
        ptr := A_PtrSize ? "Ptr" : "UInt"
        DllCall("VirtualProtect", ptr, &fun, ptr, VarSetCapacity(fun), "UInt", 0x40, "UInt*", 0)
    }
    VarSetCapacity(hex, A_IsUnicode ? 4 * len + 2 : 2 * len + 1)
    DllCall(&fun, ptr, &hex, ptr, addr, "UInt", len, "CDecl")
    VarSetCapacity(hex, -1) ; update StrLen
    Return hex
}
